unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, NWSComps_RGBCurves, NWSComps_RGBCurves_Types, StdCtrls, Buttons, jpeg, ComCtrls, ieview,
  imageenview, imageen, ImgList, ToolWin, ieopensavedlg, GIFImg, Spin, XPMan;

type
  TForm1 = class(TForm)
    PageControl_Display: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    Button4: TButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ImageList1: TImageList;
    Button_AddLayer: TButton;
    OpenImageEnDialog1: TOpenImageEnDialog;
    Button6: TButton;
    ToolButton3: TToolButton;
    Panel3: TPanel;
    Image1: TImage;
    Panel4: TPanel;
    Button7: TButton;
    Button_AddLayer_Transp: TButton;
    Panel5: TPanel;
    SpinEdit_LineSize: TSpinEdit;
    Label1: TLabel;
    CheckBox_UseGDIPlus: TCheckBox;
    Label2: TLabel;
    SpinEdit_PointSize: TSpinEdit;
    Label3: TLabel;
    SpinEdit_PointOpacity: TSpinEdit;
    Label4: TLabel;
    Panel6: TPanel;
    ImageEnView1: TImageEnView;
    CheckBox_UseFastPReview: TCheckBox;
    Label5: TLabel;
    SpeedButton1: TSpeedButton;
    Panel7: TPanel;
    PageControl1: TPageControl;
    Tab_CurvesbyPoints: TTabSheet;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    RadioGroup_Channel: TRadioGroup;
    TabFunctions: TTabSheet;
    ComboBox_Formula: TComboBox;
    Panel8: TPanel;
    ComboBox_LabelsFormat: TComboBox;
    Label6: TLabel;
    Panel9: TPanel;
    RGBCurves1: TRGBCurves;
    Panel10: TPanel;
    Label_Coords: TLabel;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RGBCurves1ChangeCurve(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ComboBox_FormulaChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PageControl_DisplayChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure Button_AddLayerClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ImageEnView1ImageChange(Sender: TObject);
    procedure Button_AddLayer_TranspClick(Sender: TObject);
    procedure RadioGroup_ChannelClick(Sender: TObject);
    procedure CheckBox_UseGDIPlusClick(Sender: TObject);
    procedure SpinEdit_LineSizeChange(Sender: TObject);
    procedure SpinEdit_PointSizeChange(Sender: TObject);
    procedure SpinEdit_PointOpacityChange(Sender: TObject);
    procedure CheckBox_UseFastPReviewClick(Sender: TObject);
    procedure RGBCurves1IEView_BeforePreview(Sender: TObject);
    procedure RGBCurves1IEView_AfterPreview(Sender: TObject);
    procedure SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ComboBox_LabelsFormatClick(Sender: TObject);
    procedure RGBCurves1CustomDraw_Labels_HorzAxis(aCanvas: TCanvas;
      const aValue: Double; var aLabel: string; var aFont: TFont; var MaxWidth,
      MaxHeight: Integer);
    procedure RGBCurves1CustomDraw_Labels_VertAxis(aCanvas: TCanvas;
      const aValue: Double; var aLabel: string; var aFont: TFont; var MaxWidth,
      MaxHeight: Integer);
    procedure RGBCurves1MovePoint(sender: TObject;
      CurrentPoint: TRGBCurves_doublePoint; CurrentPoint_Idx: Integer;
      var CanMove: TRGBCurves_CanMoveType);
    procedure RGBCurves1CustomDraw_Point(aCanvas: TCanvas;
      const thePoint: TRGBCurves_doublePoint; const theIdx: Integer;
      var theOutlineColor, theFillColor: TColor; var theSize,
      theLineSize: Cardinal; var theFillStyle: TBrushStyle);
    procedure RGBCurves1MovingPoint(sender: TObject;
      MovingPoint: TRGBCurves_doublePoint);
    procedure RGBCurves1ChangeRGBMode(Sender: TObject);
    procedure RGBCurves1AddPoint(thePointItem: TRGBCurves_PointItem);
    procedure ImageEnView1LayerNotify(Sender: TObject; layer: Integer;
      event: TIELayerEvent);
  private
    { Private declarations }
    fPreviewTime: integer;
    fReadingData: boolean;
    mems: Tmemorystream;

    procedure InitCurvesSettings;
    procedure AddLayer(const Opacity: byte);

    procedure SetDisplay;
    procedure SetCurveMode;
    procedure SetMathFunction;

    procedure Reset(const bFirstTime: boolean);
    procedure ResetImage(const bFirstTime: boolean);
    procedure ResetImageEnView;

    function GammaRed(x: single): single;
    function GammaGreen(x: single): single;
    function GammaBlue(x: single): single;

    function ContrastRed(x: single): single;
    function ContrastGreen(x: single): single;
    function ContrastBlue(x: single): single;


  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses math, hyieutils, imageenio;

{$R *.DFM}


function TForm1.GammaRed(x: single): single;
begin
  result := 255 * power(x / 255, 1.2);
end;

procedure TForm1.ImageEnView1ImageChange(Sender: TObject);
begin
  ResetImageEnView;
end;

procedure TForm1.ImageEnView1LayerNotify(Sender: TObject; layer: Integer;
  event: TIELayerEvent);
begin
  if event = ielSelected then
    ResetImageEnView;
end;

function TForm1.GammaGreen(x: single): single;
begin
  result := 255 * power(x / 255, 0.9);
end;

function TForm1.GammaBlue(x: single): single;
begin
  result := 255 * power(x / 255, 0.7);
end;

function TForm1.ContrastRed(x: single): single;
begin
  result := 1.3 * x;
end;

function TForm1.ContrastGreen(x: single): single;
begin
  result := 0.5 * x;
end;

function TForm1.ContrastBlue(x: single): single;
begin
  result := 0.7 * x;
end;


procedure TForm1.InitCurvesSettings;
begin
  fReadingData := TRUE;
  try
  RGBCurves1.HistogramDisplayMode := HDmTransparent;
  RGBCurves1.HistogramRGBMode := HmAll;
  RGBCurves1.ShowHistogram := False;
 // RGBCurves1.RGBSpace :=  csRGB;
  RGBCurves1.Layout.PointSize := SpinEdit_PointSize.Value;
  RGBCurves1.Layout.LineSize := SpinEdit_LineSize.Value;
  RGBCurves1.Layout.PointOpacity := SpinEdit_PointOpacity.Value;

  RGBCurves1.UseFastPreview := CheckBox_UseFastPReview.checked;




  RGBCurves1.OnChangeCurve := RGBCurves1ChangeCurve;
//  RGBCurves1.OnMovePoint := RGBCurves1MovePoint;
  finally
    fReadingData := FALSE;

  end;
end;


procedure TForm1.AddLayer(const Opacity: byte);
begin
   if OpenImageEnDialog1.execute then
  begin
    rgbcurves1.IEView_Preview_Lock;
    try
      imageenview1.LayersCurrent := imageenview1.LayersAdd;

      with imageenview1.layers[imageenview1.Layerscurrent] do
      begin
        Locked := false;
        Transparency := Opacity;
      end;
      imageenview1.IO.LoadFromFile(openimageendialog1.filename);
      imageenview1.OnLayerNotify(imageenview1,imageenview1.LayersCurrent, ielSelected);

    finally
      rgbcurves1.IEView_Preview_UnLock;

    end;

    

  end;

end;


procedure TForm1.SetDisplay;
begin
  if PageControl_Display.ActivePageIndex = 0 then
  begin
    RGBCurves1.IEView_Preview_UnRegister;
    RGBCurves1ChangeCurve(rgbcurves1);
  end
  else
    RGBCurves1.IEView_Preview_Register(ImageEnView1);

end;

procedure TForm1.SetCurveMode;
begin
 if pagecontrol1.ActivePage.PageIndex = 0 then
  begin
    RGBCurves1.RGBMode := TRGBCurves_rgbmode(max(0,RadioGroup_Channel.itemindex));
    RGBCurves1.CurveMode := cmBuildCurves;
  end
  else
  begin
    RGBCurves1.RGBMode := cmRGB;
    RGBCurves1.CurveMode := cmFormulaCurves;
  end;
  SetMathFunction;

end;


procedure TForm1.SetMathFunction;
begin
 case ComboBox_Formula.itemindex of
    0:
      begin
        with RGBCurves1 do
        begin
          FormulaCurve_Red := nil;
          FormulaCurve_Green := nil;
          FormulaCurve_Blue := nil;
        end;
      end;
    1:
      begin
        with RGBCurves1 do
        begin
          FormulaCurve_Red := GammaRed;
          FormulaCurve_Green := GammaGreen;
          FormulaCurve_Blue := GammaBlue;
        end;
      end;
    2:
      begin
        with RGBCurves1 do
        begin
          FormulaCurve_Red := ContrastRed;
          FormulaCurve_Green := ContrastGreen;
          FormulaCurve_Blue := ContrastBlue;
        end;
      end;
  end;
end;


procedure TForm1.SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RGBCurves1.IEView_Preview_Toggle(False);
end;

procedure TForm1.SpeedButton1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RGBCurves1.IEView_Preview_Toggle(True);
end;

procedure TForm1.SpinEdit_LineSizeChange(Sender: TObject);
begin
  if fReadingData then EXIT;

  Rgbcurves1.Layout.LineSize := SpinEdit_LineSize.Value;
end;

procedure TForm1.SpinEdit_PointOpacityChange(Sender: TObject);
begin
  if fReadingData then EXIT;

  RGBCurves1.Layout.PointOpacity := SpinEdit_PointOpacity.Value;
end;

procedure TForm1.SpinEdit_PointSizeChange(Sender: TObject);
begin
  if fReadingData then EXIT;

  RGBCurves1.Layout.PointSize := SpinEdit_PointSize.Value;
end;

procedure TForm1.RadioGroup_ChannelClick(Sender: TObject);
begin
  case RadioGroup_Channel.itemindex of
    -1, 0:
      rgbcurves1.RGBMode := cmall;
    1:
      rgbcurves1.RGBMode := cmred;
    2:
      rgbcurves1.RGBMode := cmgreen;
    3:
      rgbcurves1.RGBMode := cmblue;
  end;
end;

procedure TForm1.RGBCurves1ChangeRGBMode(Sender: TObject);
begin
 case rgbcurves1.RGBMode of
    cmall: RadioGroup_Channel.itemindex := 0;
    cmRed: RadioGroup_Channel.itemindex := 1;
    cmgreen: RadioGroup_Channel.itemindex := 2;
    cmblue: RadioGroup_Channel.itemindex := 3;

  end;
end;

procedure TForm1.Reset(const bFirstTime: boolean);
begin
  if PageControl_Display.ActivePage.PageIndex = 0 then
  begin
    ResetImage(bFirstTime);
  end
  else
  begin
    ResetImageEnView;
  end;

end;

procedure TForm1.ResetImage(const bFirstTime: boolean);
var
  bmp: TBitmap;
begin
  mems.seek(0, 0);
  if bFirstTime then
  begin

    bmp := Tbitmap.create;
    try

    bmp.Assign(image1.picture.graphic);

    bmp.savetostream(mems);
    RGBCurves1.GetHistogramfromBMP(bmp);

    finally
      bmp.Free;
    end;
  end
  else
  begin
    image1.picture.bitmap.savetostream(mems);
    RGBCurves1.GetHistogramfromBMP(image1.picture.bitmap);
  end;

  RGBCurves1.ShowHistogram := True;
end;

procedure TForm1.ResetImageEnView;
begin
  RGBCurves1.GetHistogramfromIEBMP(ImageEnView1.CurrentLayer.Bitmap);
  RGBCurves1.ShowHistogram := True;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  fReadingData := False;
  RadioGroup_Channel.itemindex := 0;
  ComboBox_Formula.itemindex := 0;

  mems := Tmemorystream.create;

  imageenview1.LayersSync := false;

  InitCurvesSettings;

  Reset(True);

  SetCurveMode;

  SetDisplay;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  mems.free;
end;


procedure TForm1.RGBCurves1AddPoint(thePointItem: TRGBCurves_PointItem);
var
  channelColor: TColor;
begin
{
  case RGBCurves1.RGBMode of

    cmRed: channelColor := RGBCurves1.Layout.PointColor_Red;
    cmGreen: channelColor := RGBCurves1.Layout.PointColor_Green;
    cmBlue: channelColor := RGBCurves1.Layout.PointColor_Blue;
    cmAll: channelColor := RGBCurves1.Layout.PointColor_Lum;
  end;

  thePointitem.SetCustom(clpurple,
                           channelColor,
                           RGBCurves1.Layout.PointSize,
                           RGBCurves1.Layout.LineSize);
                           }
end;

procedure TForm1.RGBCurves1ChangeCurve(Sender: TObject);
begin

  if PageControl_Display.ActivePageIndex = 0 then
  begin
    if assigned(image1.picture.bitmap) then
    begin
      mems.seek(0, 0);
      image1.picture.bitmap.LoadFromStream(mems);
      rgbcurves1.ApplyCurvestoBitmap(image1.picture.bitmap);
      image1.refresh;
    end;
  end;
  
end;




procedure TForm1.RGBCurves1CustomDraw_Labels_HorzAxis(aCanvas: TCanvas;
  const aValue: Double; var aLabel: string; var aFont: TFont; var MaxWidth,
  MaxHeight: Integer);
function GetInkPerc(theValue:double): integer;
begin
  result := round(100 - aValue/255 *100);
end;

begin
  case ComboBox_LabelsFormat.ItemIndex of
    1:
    begin
     aLabel := inttostr(GetInkPerc(aValue));
     MaxWidth := aCanvas.TextWidth('100');
     MaxHeight := aCanvas.TextHeight('100');
    end;
  end;

  case RGBCurves1.RGBMode of
    cmAll: aFont.Color := RGBCurves1.Layout.CurveColor_Lum;
    cmRed: aFont.Color := RGBCurves1.Layout.CurveColor_Red;
    cmGreen: aFont.Color := RGBCurves1.Layout.CurveColor_Green;
    cmBlue: aFont.Color := RGBCurves1.Layout.CurveColor_Blue;
    cmRGB: aFont.Color := RGBCurves1.Layout.CurveColor_Lum;
  end;
end;

procedure TForm1.RGBCurves1CustomDraw_Labels_VertAxis(aCanvas: TCanvas;
  const aValue: Double; var aLabel: string; var aFont: TFont; var MaxWidth,
  MaxHeight: Integer);
function GetInkPerc(theValue:double): integer;
begin
  result := round(100 - aValue/255 *100);
end;

begin
  case ComboBox_LabelsFormat.ItemIndex of
    1:
    begin
     aLabel := inttostr(GetInkPerc(aValue));
     MaxWidth := aCanvas.TextWidth('100');
     MaxHeight := aCanvas.TextHeight('100');
    end;
  end;

  case RGBCurves1.RGBMode of
    cmAll: aFont.Color := RGBCurves1.Layout.CurveColor_Lum;
    cmRed: aFont.Color := RGBCurves1.Layout.CurveColor_Red;
    cmGreen: aFont.Color := RGBCurves1.Layout.CurveColor_Green;
    cmBlue: aFont.Color := RGBCurves1.Layout.CurveColor_Blue;
    cmRGB: aFont.Color := RGBCurves1.Layout.CurveColor_Lum;
  end;
end;

procedure TForm1.RGBCurves1CustomDraw_Point(aCanvas: TCanvas;
  const thePoint: TRGBCurves_doublePoint; const theIdx: Integer;
  var theOutlineColor, theFillColor: TColor; var theSize, theLineSize: Cardinal;
  var theFillStyle: TBrushStyle);
begin
   if theIdx = rgbcurves1.GetCurrentPoint_IDX then
   begin
      theOutlineColor := clgray;
      theLineSize := theLineSize + 1;
   end;
end;

procedure TForm1.RGBCurves1IEView_AfterPreview(Sender: TObject);
begin
  label5.Caption := 'Previewed in ' + inttostr(Gettickcount - fPreviewTime) + ' millisecs';
end;

procedure TForm1.RGBCurves1IEView_BeforePreview(Sender: TObject);
begin
  fPreviewTime := GetTickCount;
end;

procedure TForm1.RGBCurves1MovePoint(sender: TObject;
  CurrentPoint: TRGBCurves_doublePoint; CurrentPoint_Idx: Integer;
  var CanMove: TRGBCurves_CanMoveType);
begin
  Label_Coords.Caption := 'X = ' + formatfloat('#.##', CurrentPoint.x) +  ' Y = ' + formatfloat('#.##', CurrentPoint.y)

end;

procedure TForm1.RGBCurves1MovingPoint(sender: TObject;
  MovingPoint: TRGBCurves_doublePoint);
begin
  Label_Coords.Caption := 'X = ' + formatfloat('#.##', MovingPoint.x) +  ' Y = ' + formatfloat('#.##', MovingPoint.y)

end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  SetCurveMode;
end;



procedure TForm1.PageControl_DisplayChange(Sender: TObject);
begin
  SetDisplay;
end;


procedure TForm1.CheckBox_UseFastPReviewClick(Sender: TObject);
begin
  RGBCurves1.UseFastPreview := CheckBox_UseFastPReview.Checked;
end;

procedure TForm1.CheckBox_UseGDIPlusClick(Sender: TObject);
begin
  RGBCurves1.UseGDIPlus := CheckBox_UseGDIPlus.Checked;
end;

procedure TForm1.ComboBox_FormulaChange(Sender: TObject);
begin
 SetMathFunction;
end;


procedure TForm1.ComboBox_LabelsFormatClick(Sender: TObject);
begin
  rgbcurves1.Refresh;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  rgbcurves1.ImportCurves;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  RGBCurves1.ExportCurves;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  rgbcurves1.ResetPoints;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  RGBCurves1.IEView_Preview_ApplyChanges;
  ResetImageEnView;
  ComboBox_Formula.ItemIndex := 0;
  SetMathFunction;
  RGBCurves1.ResetPoints;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  ImageEnView1.MouseInteract := [miZoom,miScroll];
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  ImageEnView1.MouseInteract := [miSelectLasso];
end;


procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  ImageEnView1.MouseInteract := [miMoveLayers, miResizeLayers];
end;


procedure TForm1.Button_AddLayerClick(Sender: TObject);
begin
 AddLayer(255);
end;

procedure TForm1.Button_AddLayer_TranspClick(Sender: TObject);
begin
  AddLayer(180);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if OpenImageEnDialog1.Execute then
  begin
    rgbcurves1.IEView_Preview_Lock;
    try
    ImageEnView1.LayersCurrent := 0;
    ImageEnView1.IO.loadfromfile(OpenImageEnDialog1.FileName);
    finally
      rgbcurves1.IEView_Preview_UnLock;

    end;
  end;
end;



procedure TForm1.Button7Click(Sender: TObject);
var
  io: TImageenio;
begin

  if OpenImageEnDialog1.Execute then
  begin
    io := TImageEnIO.Create(nil);
    try
    io.AttachedBitmap := Image1.Picture.Bitmap;
    io.LoadFromFile(OpenImageEnDialog1.FileName);
    ResetImage(False);
    finally

      io.Free;
    end;
  end;
end;

end.
